Loading...
Searching...
No Matches
Gudhi::alpha_complex::SimplicialComplexForAlpha Struct Reference

The concept SimplicialComplexForAlpha describes the requirements for a type to implement a simplicial complex, that can be created from a Alpha_complex. More...

`#include <concept/Alpha_complex/SimplicialComplexForAlpha.h>`

## Public Types

typedef unspecified | Simplex_handle
typedef unspecified | Vertex_handle
typedef unspecified | Filtration_value
typedef unspecified | Simplex_vertex_range
| Iterator over vertices of a simplex.
typedef unspecified | Boundary_simplex_range
| Iterator over the boundaries of the complex, in an arbitrary order.
typedef unspecified | Skeleton_simplex_range
| Iterator over the simplices of the skeleton of the complex, for a given dimension.
typedef unspecified | Insertion_result_type
| Return type of an insertion of a simplex.

## Public Member Functions

std::size_t | num_vertices ()
int | dimension (Simplex_handle simplex)
int | assign_filtration (Simplex_handle simplex, Filtration_value filtration)
void | insert_simplex_and_subfaces (std::vector< Vertex_handle > const &vertex_range, Filtration_value filtration)
| Inserts a simplex with vertices from a given simplex (represented by a vector of Vertex_handle) in the simplicial complex with the given 'filtration' value.
void | make_filtration_non_decreasing ()
void | prune_above_filtration (Filtration_value filtration)
Simplex_vertex_range | simplex_vertex_range (Simplex_handle const &simplex)
| Returns a range over vertices of a given simplex.
Boundary_simplex_range | boundary_simplex_range (Simplex_handle const &simplex)
| Returns a range over boundaries of a given simplex.

## Public Attributes

Skeleton_simplex_range | skeleton_simplex_range
| Returns a range over the simplices of the skeleton of the simplicial complex, for a given dimension.

## Map interface

Conceptually a std::unordered_map<Simplex_handle,std::size_t>.
typedef unspecified | Simplex_key
| Data stored for each simplex.
Simplex_key | null_key ()
| Returns a constant dummy number that is either negative, or at least as large as the number of simplices. Suggested value: -1.
Simplex_key | key (Simplex_handle sh)
| Returns the number stored for a simplex by assign_key().
void | assign_key (Simplex_handle sh, Simplex_key n)
| Store a number for a simplex, which can later be retrieved with key().

## Detailed Description

The concept SimplicialComplexForAlpha describes the requirements for a type to implement a simplicial complex, that can be created from a Alpha_complex.

## Member Typedef Documentation

## Boundary_simplex_range

typedef unspecified Gudhi::alpha_complex::SimplicialComplexForAlpha::Boundary_simplex_range

Iterator over the boundaries of the complex, in an arbitrary order.

'value_type' must be 'Simplex_handle'.

## Filtration_value

typedef unspecified Gudhi::alpha_complex::SimplicialComplexForAlpha::Filtration_value

Simplex filtration value type. Must be capable to represent the special value "Not-A-Number". If a specific filtration value type is provided, and Output_squared_values is set to false, you may have to provide an sqrt methods that fits your needs.

## Simplex_handle

typedef unspecified Gudhi::alpha_complex::SimplicialComplexForAlpha::Simplex_handle

Handle to specify a simplex.

## Simplex_key

typedef unspecified Gudhi::alpha_complex::SimplicialComplexForAlpha::Simplex_key

Data stored for each simplex.

Must be an integer type.

## Simplex_vertex_range

typedef unspecified Gudhi::alpha_complex::SimplicialComplexForAlpha::Simplex_vertex_range

Iterator over vertices of a simplex.

'value type' must be 'Vertex_handle'.

## Skeleton_simplex_range

typedef unspecified Gudhi::alpha_complex::SimplicialComplexForAlpha::Skeleton_simplex_range

Iterator over the simplices of the skeleton of the complex, for a given dimension.

'value_type' must be 'Simplex_handle'.

## Vertex_handle

typedef unspecified Gudhi::alpha_complex::SimplicialComplexForAlpha::Vertex_handle

Handle to specify a vertex. Must be a non-negative integer.

## Member Function Documentation

## assign_filtration()

int Gudhi::alpha_complex::SimplicialComplexForAlpha::assign_filtration | ( | Simplex_handle | simplex,
|  | Filtration_value | filtration )

Assigns the 'simplex' with the given 'filtration' value.

## dimension()

int Gudhi::alpha_complex::SimplicialComplexForAlpha::dimension | ( | Simplex_handle | simplex | ) |

Gets the 'simplex' dimension.

## key()

Simplex_key Gudhi::alpha_complex::SimplicialComplexForAlpha::key | ( | Simplex_handle | sh | ) |

Returns the number stored for a simplex by assign_key().

If assign_key() has not been called, it must return null_key().

## make_filtration_non_decreasing()

void Gudhi::alpha_complex::SimplicialComplexForAlpha::make_filtration_non_decreasing | ( |  | ) |

Browses the simplicial complex to make the filtration non-decreasing.

## num_vertices()

std::size_t Gudhi::alpha_complex::SimplicialComplexForAlpha::num_vertices | ( |  | ) |

Returns the number of vertices in the simplicial complex.

## prune_above_filtration()

void Gudhi::alpha_complex::SimplicialComplexForAlpha::prune_above_filtration | ( | Filtration_value | filtration | ) |

Prune the simplicial complex above 'filtration' value given as parameter.

The documentation for this struct was generated from the following file:

- concept/Alpha_complex/SimplicialComplexForAlpha.h